(***************************************************************************)
(***************************************************************************)
(****                                                                  	****)
(****		Copyright (c) 1995-1996 M. Maher AL-Rijleh											****)
(****                                                                   ****)
(****		Component 	: TNumberEdit	(32 Bit)															****)
(****		version		: 1.00																								****)
(****		Date			: 09/28/1995																					****)
(****		Last Update	: 03/01/1996																				****)
(**** 	Description	: An edit box that handle numerical entries					****)
(****                                                                  	****)
(***************************************************************************)
(***************************************************************************)

(***************************************************************************)
(***************************************************************************)
(****                                                                  	****)
(**** This code may be altered by you as you wish to make TNumberEdit		****)
(**** function to your personal needs. However, you cannot resell or 		****)
(***	redistribute the TNumberEdit as your own, altered or unaltered in ****)
(***	component or other non-executable form.														****)
(****                                                                  	****)
(***************************************************************************)
(***************************************************************************)
unit W_calc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Numedit, Buttons;

type
  TCalculator = class(TForm)
    pnlBack: TPanel;
    Bevel1: TBevel;
    btn7: TSpeedButton;
    btn8: TSpeedButton;
    btn9: TSpeedButton;
    btn4: TSpeedButton;
    btn5: TSpeedButton;
    btn6: TSpeedButton;
    btn1: TSpeedButton;
    btn2: TSpeedButton;
    btn3: TSpeedButton;
    btn0: TSpeedButton;
    btnPeriod: TSpeedButton;
    btnPlusMinus: TSpeedButton;
    btnClear: TSpeedButton;
    btnPlus: TSpeedButton;
    btnMinus: TSpeedButton;
    btnMultiply: TSpeedButton;
    btnDivide: TSpeedButton;
    btnEqual: TSpeedButton;
    btnFact: TSpeedButton;
    btn1Over: TSpeedButton;
    btnSqr: TSpeedButton;
    btnPower: TSpeedButton;
    btnSin: TSpeedButton;
    btnCos: TSpeedButton;
    btnTan: TSpeedButton;
    btnOK: TSpeedButton;
    btnlnx: TSpeedButton;
    btnCancel: TSpeedButton;
    btnDecimalFigures: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    btnExp: TSpeedButton;
    Label9: TLabel;
    Label10: TLabel;
    NumberEdit1: TNumberEdit;
    Panel1: TPanel;
    ListBox1: TListBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    ListBox2: TListBox;
    Bevel2: TBevel;
    btnSqrt: TSpeedButton;
    Label11: TLabel;
    btnTape: TSpeedButton;
    procedure NumberEdit1Change(Sender: TObject);
    procedure btnNumberClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnPlusMinusClick(Sender: TObject);
    procedure btnPlusClick(Sender: TObject);
    procedure btnEqualClick(Sender: TObject);
    procedure btnFactClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btn1OverClick(Sender: TObject);
    procedure btnDecimalFiguresClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure btnSqrClick(Sender: TObject);
    procedure btnSinClick(Sender: TObject);
    procedure btnCosClick(Sender: TObject);
    procedure btnTanClick(Sender: TObject);
    procedure btnlnxClick(Sender: TObject);
    procedure btnExpClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure btnTapeClick(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure btnSqrtClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure NumberEdit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
    XRegister : TFloat;
    YRegister : TFloat;
    Operation : string;
    NeedReset : Boolean;
    AfterEqual : Boolean;
    chrProssesed : Boolean;
    procedure PushRegister;
    function ConvertAngle:TFloat;
    Procedure AddtoTape(const s : string);
  end;



implementation

{$R *.DFM}

const
	Seperator : string[11] = '-----------';

procedure TCalculator.PushRegister;
begin
	YRegister := XRegister;
  XRegister := NumberEdit1.Value;
  if not AfterEqual then
  	AddtoTape(Floattostr(NumberEdit1.value));
  NeedReset := true;
  AfterEqual := false;
end;

Procedure TCalculator.AddtoTape(const s : string);
begin
	ListBox2.Items.add(s);
  ListBox2.ItemIndex := ListBox2.Items.count-1;
end;

function TCalculator.ConvertAngle:TFloat;
begin
	if RadioButton1.checked then
  	result :=  NumberEdit1.value * PI / 180
  else
    result :=  NumberEdit1.value;
end;

procedure TCalculator.FormShow(Sender: TObject);
begin
	NumberEdit1change(sender);
	NumberEdit1.SelStart := 1;
end;

procedure TCalculator.NumberEdit1Change(Sender: TObject);
begin
	Panel1.caption := NumberEdit1.text;
end;

procedure TCalculator.btnNumberClick(Sender: TObject);
begin
	if NeedReset then
  begin
  	if AfterEqual then
  		PushRegister;
  	NumberEdit1.value :=0;
    NumberEdit1.SelStart := 1;
    NeedReset := false;
    AfterEqual := false;
  end;
	Sendmessage(NumberEdit1.Handle,WM_Char,ord(TSpeedButton(Sender).Caption[1]),0);
end;

procedure TCalculator.btnClearClick(Sender: TObject);
begin
	PushRegister;
	NumberEdit1.Value := 0;
  NumberEdit1.SelStart := 1;
end;

procedure TCalculator.BitBtn1Click(Sender: TObject);
begin
	NumberEdit1.value := sin(NumberEdit1.value);
end;

procedure TCalculator.FormCreate(Sender: TObject);
begin
	NumberEdit1.LockDecimalFigures := true;
	Panel1.top := NumberEdit1.top;
  panel1.height := NumberEdit1.Height;
  panel1.left := NumberEdit1.Left;
  AfterEqual := false;
  Operation := '';
  Bevel1.SendToBack;
  Bevel2.SendToBack;
  chrProssesed := false;
end;

procedure TCalculator.btnPlusMinusClick(Sender: TObject);
begin
	NumberEdit1.value := -NumberEdit1.value;
  NumberEdit1.SelStart := Length (NumberEdit1.text) -
  	NumberEdit1.DecimalFigures - 1;
end;

procedure TCalculator.btnPlusClick(Sender: TObject);
begin
	btnEqualClick(Sender);
	PushRegister;
  AddtoTape(TSpeedButton(Sender).caption);
  Operation := TSpeedButton(Sender).caption;
end;

procedure TCalculator.btnEqualClick(Sender: TObject);
begin
	if Operation = '' then
  	exit;
	PushRegister;
  AfterEqual := true;
  AddtoTape(Seperator);
	if operation = '+' then
  	NumberEdit1.value := XRegister + YRegister
  else if operation = '-' then
  	NumberEdit1.value := YRegister - XRegister
	else if operation = '*' then
  	NumberEdit1.value := YRegister * XRegister
  else if operation = '/' then
  	if XRegister <> 0 then
    	NumberEdit1.value := YRegister / XRegister
    else
    	Panel1.caption := 'Error'
  else if operation = 'y^x' then
  	NumberEdit1.value := Exp(XRegister * ln(YRegister));
  Operation := '';
  AddtoTape(NumberEdit1.Text);
end;

procedure TCalculator.btnFactClick(Sender: TObject);
var
	T : TFloat;
begin
	PushRegister;
  Addtotape(btnFact.Caption);
	if int(NumberEdit1.value)<> NumberEdit1.value then
  	Panel1.caption := 'Error'
  else begin
  	T := 1;
    try
      while NumberEdit1.Value > 0 do
      begin
      	T := T * NumberEdit1.value;
        NumberEdit1.value := NumberEdit1.value - 1;
      end;
      NumberEdit1.value := T;
    except
    	Panel1.caption := 'Error'
    end;
  end;
end;

procedure TCalculator.btnCancelClick(Sender: TObject);
begin
	ModalResult := mrCancel; 
end;

procedure TCalculator.btnOKClick(Sender: TObject);
begin
	ModalResult := mrOK;
end;

procedure TCalculator.btn1OverClick(Sender: TObject);
begin
	PushRegister;
  Addtotape(btn1Over.Caption);
	if NumberEdit1.value  = 0 then
  	Panel1.Caption := 'error'
  else
  	NumberEdit1.value := 1 / NumberEdit1.value;
end;

procedure TCalculator.btnDecimalFiguresClick(Sender: TObject);
begin
	ListBox1.Width := 120;
  ListBox1.Height := 100;
  ListBox1.Top := btnDecimalFigures.Top + btnDecimalFigures.Height;
  ListBox1.Left := btnDecimalFigures.left + btnDecimalFigures.Width -
  	ListBox1.Width;
  ListBox1.ItemIndex := NumberEdit1.DecimalFigures;
	ListBox1.visible := not ListBox1.visible;
  ListBox1.BringtoFront;
end;

procedure TCalculator.ListBox1Click(Sender: TObject);
begin
	NumberEdit1.DecimalFigures := ListBox1.ItemIndex;
  NumberEdit1.SetFocus;
	ListBox1.Visible := false;
end;

procedure TCalculator.btnSqrClick(Sender: TObject);
begin
	PushRegister;
  Addtotape(btnSqr.Caption);
	try
		NumberEdit1.value := NumberEdit1.value * NumberEdit1.value;
  except
  	Panel1.Caption := 'Error';
  end;
end;

procedure TCalculator.btnSinClick(Sender: TObject);
begin
	PushRegister;
  Addtotape(btnsin.Caption);
	NumberEdit1.value := sin(ConvertAngle);
end;

procedure TCalculator.btnCosClick(Sender: TObject);
begin
	PushRegister;
  Addtotape(btncos.Caption);
	NumberEdit1.value := cos(ConvertAngle);
end;

procedure TCalculator.btnTanClick(Sender: TObject);
begin
	PushRegister;
  Addtotape(btntan.Caption);
	if cos(ConvertAngle)=0 then
  	panel1.caption := 'Error'
  else
		NumberEdit1.value := sin(ConvertAngle)/cos(ConvertAngle);
end;

procedure TCalculator.btnlnxClick(Sender: TObject);
begin
	PushRegister;
  Addtotape(btnlnx.Caption);
	if NumberEdit1.value <= 0 then
  	panel1.caption := 'Error'
  else
	NumberEdit1.value := ln(NumberEdit1.value);
end;

procedure TCalculator.btnExpClick(Sender: TObject);
begin
	PushRegister;
  Addtotape(btnExp.Caption);
	try
		NumberEdit1.value := Exp(NumberEdit1.value);
  except
  	Panel1.Caption := 'Error';
  end;
end;

procedure TCalculator.FormKeyPress(Sender: TObject; var Key: Char);
begin
	chrProssesed := false;
	if (key = '=') or (key = chr(VK_RETURN)) then
  begin
  	chrProssesed := true;
  	key := #0;
    btnEqualClick(Sender);
  end	else if (key in ['+', '-', '*', '/']) then
  begin
  	chrProssesed := true;
  	PushRegister;
    AddToTape(Key);
  	Operation := key;
    key := #0;
  end else if key = chr(VK_F10) then
	begin
  	chrProssesed := true;
  	key := #0;
    btnPlusMinusClick(Sender);
  end else if key = chr(VK_F1) then
  begin
  	chrProssesed := true;
  	key := #0;
    btnFactClick(sender);
  end else if key = chr(VK_F2) then
  begin
  	chrProssesed := true;
  	key := #0;
    btn1OverClick(sender);
  end else if key = chr(VK_F3) then
  begin
  	chrProssesed := true;
  	key := #0;
    btnSqrClick(sender);
  end else if key = chr(VK_F4) then
  begin
  	chrProssesed := true;
  	key := #0;
    btnSqrtClick(sender);
  end else if key = chr(VK_F6) then
  begin
  	chrProssesed := true;
  	key := #0;
    btnSinClick(sender);
  end else if key = chr(VK_F7) then
  begin
  	chrProssesed := true;
  	key := #0;
    btnCosClick(sender);
  end else if key = chr(VK_F8) then
  begin
  	chrProssesed := true;
  	key := #0;
    btntanClick(sender);
  end else if key = chr(VK_F9) then
  begin
  	chrProssesed := true;
  	key := #0;
    btnlnxClick(sender);
  end else if key = chr(VK_F11) then
  begin
  	chrProssesed := true;
  	key := #0;
    btnExpClick(sender);
  end else if key = chr(VK_F12) then
  begin
  	chrProssesed := true;
  	key := #0;
    btnPlusMinusClick(sender);
  end else if Upcase(key) = 'C' then
  begin
  	chrProssesed := true;
  	key := #0;
    btnClearClick(sender);
  end else if (not (key in ['0'..'9','.'])) then
  begin
  	chrProssesed := true;
  	key := #0;
{    messagebeep(0);}
  end else if NeedReset then
  begin
  	if NeedReset then
  	begin
  		if AfterEqual then
  			PushRegister;
  		NumberEdit1.value :=0;
    	NumberEdit1.SelStart := 1;
    	NeedReset := false;
    	AfterEqual := false;
  	end;
    chrProssesed := false;
  end;
end;

procedure TCalculator.RadioButton1Click(Sender: TObject);
begin
	NumberEdit1.SetFocus;
end;

procedure TCalculator.RadioButton2Click(Sender: TObject);
begin
	NumberEdit1.SetFocus;
end;

procedure TCalculator.btnTapeClick(Sender: TObject);
begin
	ListBox2.Width := 120;
  ListBox2.Height := 100;
  ListBox2.Top := btnTape.Top + btnTape.Height;
  ListBox2.Left := btnTape.left + btnTape.Width -
  	ListBox2.Width;
  ListBox2.ItemIndex := ListBox2.Items.count-1;
	ListBox2.visible := not ListBox2.visible;
  ListBox2.BringtoFront;
end;

procedure TCalculator.ListBox2Click(Sender: TObject);
var
	err : integer;
  temp : TFloat;
begin
	val(ListBox2.Items[ListBox2.ItemIndex], temp, err);
  if err=0 then
		NumberEdit1.text := ListBox2.Items[ListBox2.ItemIndex];
  NumberEdit1.SetFocus;
	ListBox2.Visible := false;
end;

procedure TCalculator.Panel1Click(Sender: TObject);
begin
	if ListBox1.visible then
  	ListBox1Click(Sender)
	else if ListBox2.visible then
  	ListBox2Click(Sender)
  else
		NumberEdit1.setFocus;
end;

procedure TCalculator.btnSqrtClick(Sender: TObject);
begin
	PushRegister;
  Addtotape(btnsqrt.Caption);
	if NumberEdit1.value>=0 then
		NumberEdit1.value := sqrt (NumberEdit1.value)
  else
  	Panel1.Caption := 'Error';
end;

procedure TCalculator.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
	ch : char;
begin
	if (key=0) or (chrProssesed) or (key=VK_NUMPAD3) then
  begin
  	chrProssesed := false;
  	exit;
  end;
	ch := chr(key);
	FormKeyPress(Sender, ch);
  key := ord(ch);
  chrProssesed := false;
end;

procedure TCalculator.NumberEdit1KeyPress(Sender: TObject; var Key: Char);
begin
{	if (not (key in ['0'..'9','.'])) then}
		FormKeyPress(Sender,Key);
end;

end.
